package com.cemarose.mongodb.config;

import com.mongodb.*;
import org.springframework.context.annotation.Bean;
import org.springframework.data.mongodb.MongoDbFactory;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.SimpleMongoDbFactory;
import org.springframework.stereotype.Component;

@Component
public class MongoConfig {


    /**
     * 初始化mongodb客户端
     * @return
     */
    @Bean
    public MongoClient client() {
        return new MongoClient(new ServerAddress("127.0.0.1", 27017));
    }

    /**
     * 初始化factory
     * @return
     * @throws Exception
     */
    @Bean
    public MongoDbFactory mongoDbFactory() throws Exception{
        String database = new MongoClientURI("mongodb://localhost/dbtest").getDatabase();
        return new SimpleMongoDbFactory(client(), database);
    }

    /**
     * factory加载到MongoTemplate
     * @param mongoDbFactory
     * @return
     */
    @Bean
    public MongoTemplate mongoTemplete(MongoDbFactory mongoDbFactory){
        return new MongoTemplate(mongoDbFactory);
    }

    /**
     * test
     */
    public void example(MongoDbFactory mongoDbFactory) {
        DB db = mongoDbFactory.getDb();
        DBCollection collection = db.getCollection("users");

    }

}
